import java.awt.*;

class graphicsScreen extends java.awt.Frame {

    Graphics g;
  	int width, hight;    
    private Canvas canvas;
  
    /** Creates new form graphicsScreen */
    public graphicsScreen(int xsize, int ysize) {
        initComponents ();
        canvas.setBounds(0,0,xsize,ysize);
        pack ();
        g=canvas.getGraphics();
        g.setClip(0,0,xsize,ysize);
        width=xsize;
        hight=ysize;
        clear();
		show();
    }

    public void plot(int x, int y, Color c){
        g.setColor(c);
        g.fillRect(x,y,1,1);
    }

    public void dot(int x, int y, int r, Color c){
        g.setColor(c);
        g.fillOval(x-r/2,y-r/2,r,r);
    }
    
    public void line(int fx, int fy, int tx, int ty, Color c){
        g.setColor(c);
    	g.drawLine(fx,fy,tx,ty);
    }

	public void clear(){
		g.setColor(Color.white);
        g.fillRect(0,0,width,hight);			
	}

    private void initComponents () {
        canvas = new java.awt.Canvas ();
        setLayout (new java.awt.FlowLayout ());

        addWindowListener (new java.awt.event.WindowAdapter () {
            public void windowClosing (java.awt.event.WindowEvent evt) {
                exitForm (evt);
            }
        }
        );
        canvas.setBackground (java.awt.Color.white);
        add (canvas);
    }

    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit (0);
    }
}
